using System;
using Example2a.Rules;

namespace Example2a.Framework {

	public class Engine {

		static private CompiledRuleSet rules;
	
		static public void Initialize() {
			rules = new RuleSetTest();
			rules.Initialize();
		}

		static public bool IsValid(Object targetObject) {
			foreach (CompiledRule rule in rules) {
				if (rule.IsApplicable(targetObject)) {
					if (!rule.IsValid(targetObject)) {
						return false;
					}
				}
			}
			return true;
		}
	}
}
