using System;

namespace Example2b.Framework {

	public class Engine {

		static private CompiledRuleSet rules;
	
		static public void Initialize() {
			Compiler compiler = new Compiler();
			rules = compiler.CompileRuleSetFromFile("RuleSetTest.xml");
			rules.Initialize();
		}

		static public bool IsValid(object target) {
			foreach (CompiledRule rule in rules) {
				if (rule.IsApplicable(target)) {
					if (!rule.IsValid(target)) {
						return false;
					}
				}
			}
			return true;
		}
		static public ValidationResult Validate1(object target) {
			ValidationResult result = new ValidationResult();
			foreach (CompiledRule rule in rules) {
				if (rule.IsApplicable(target)) {
					if (!rule.IsValid(target)) {
						result.IsValid = false;
						result.Rule = rule;
						return result;
					}
				}
			}
			return result;
		}
	}
}
